{1- Cree un archivo secuencial llamado ENTEROS.DAT cuyos elementos sean nmeros enteros.}
{El programa debe:}
{Abrir el archivo para lectura/escritura en modo binario.}
{Cargar datos en el archivo.}
{Leer el primer registro.}
{Imprimir ese registro.}
{Cerrar el archivo.}
{Es preciso aclarar que, en este problema resuelto, utilizamos la palabra registro para referirnos a una variable atmica (ya que, en este caso, los elementos del archivo son nmeros enteros).}
{Solucin en lenguaje Pascal}

PROGRAM cap07_ej01;

CONST EOFF = -1;

TYPE t_arch = FILE OF INTEGER;

VAR fp: t_arch;
	numero, extraido: INTEGER;

{ Programa Principal }
BEGIN

	ASSIGN(fp,'enteros.dat');

	{$I-}
	REWRITE(fp);
	{$I+}
	IF (IORESULT <> 0) THEN
		BEGIN
			WRITELN('No se puede abrir el archivo.');
			EXIT;
		END;

	REPEAT
		WRITE('Ingrese un entero (', EOFF, ' para terminar): ');
		READLN(numero);
		IF (numero <> EOFF) THEN
			BEGIN
			{$I-}
			WRITE(fp, numero);
			{$I+}
			IF (IORESULT <> 0) THEN
				BEGIN
					WRITELN('Error escribiendo en el archivo.');
					CLOSE(fp);
					EXIT;
				END;
			END;
		UNTIL (numero = EOFF);
		RESET(fp);

		{$I-}
		READ(fp, extraido);
		{$I+}
		IF (IORESULT <> 0) THEN
			BEGIN
				WRITELN('Error leyendo del archivo.');
				CLOSE(fp);
				EXIT;
			END;

		WRITELN(extraido);
		CLOSE(fp);
END.