/* 4- Cree un archivo binario, cuyos registros contengan los siguientes campos: */
/* Cdigo (entero). */
/* Descripcin (cadena de caracteres).*/
/* Precio unitario (real).*/
/* El programa debe permitir la carga de datos en el archivo. Luego, leer y mostrar el ltimo registro vlido del archivo (anterior al EOF). Con ulterioridad se debe posicionar sobre la marca de fin de archivo (EOF) y permitir agregar datos nuevos al final. Por ltimo, mostrar el contenido del archivo completo.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define N 100

typedef struct {
	int codigo;
	char descripcion[50];
	float precio_unit;
} t_producto;

/* Prototipos */
t_producto cargar_producto();
void imprimir_producto(t_producto);
int main()
{
	FILE *stock;
	t_producto buffer;
	int i;

	if ((stock=fopen("stock.dat","wb+")) == NULL)
	{
		printf("No se puede abrir el archivo.\n");
		return 1;

	}/* Carga de datos en el archivo */
	for (i=0; i<N; i++)
	{
		buffer = cargar_producto();
		fwrite(&buffer, sizeof(t_producto), 1, stock);
	}

	/* Lectura del ltimo registro (registro N-1) */
	fseek(stock, (N-1)*sizeof(t_producto), SEEK_SET);
	fread(&buffer, sizeof(t_producto), 1, stock);
	imprimir_producto(buffer);

	/* Posicionamiento sobre EOF (para agregar un registro al final) */
	fseek(stock, 0, SEEK_END);
	buffer = cargar_producto();
	fwrite(&buffer, sizeof(t_producto), 1, stock);

	/* Listado secuencial del archivo */
	rewind(stock);
	while (!feof(stock))
	{
		fread(&buffer, sizeof(t_producto), 1, stock);
		imprimir_producto(buffer);
	}
	fclose(stock);

	return 0;
	}
	t_producto cargar_producto()
	{
		t_producto buffer;
		printf("DATOS DEL PRODUCTO\n");
		printf(" Cdigo: ");
		scanf("%d", &(buffer.codigo));
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf(" Descripcin: ");
		fgets(buffer.descripcion, 50, stdin);
		if (buffer.descripcion[strlen(buffer.descripcion)-1] == '\n')
			buffer.descripcion[strlen(buffer.descripcion)-1] = '\0';
		else
			while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf(" Precio unitario: ");
		scanf("%f",&(buffer.precio_unit));
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf("\n");
	return buffer;
}

void imprimir_producto(t_producto producto)
{
	printf("DATOS DEL PRODUCTO\n");
	printf(" Cdigo: %d\n", producto.codigo);
	printf(" Descripcion: %s\n", producto.descripcion);
	printf(" Precio unitario: %f\n", producto.precio_unit);
	printf("\n");
}