{4- Cree un archivo binario, cuyos registros contengan los siguientes campos:}
{Cdigo (entero).}
{Descripcin (cadena de caracteres).}
{Precio unitario (real).}
{El programa debe permitir la carga de datos en el archivo. Luego, leer y mostrar el ltimo registro vlido del archivo (anterior al EOF). Con ulterioridad se debe posicionar sobre la marca de fin de archivo (EOF) y permitir agregar datos nuevos al final. Por ltimo, mostrar el contenido del archivo completo.}
{Solucin en lenguaje Pascal}

PROGRAM cap07_ej04;

CONST N = 100;

TYPE 	t_producto = RECORD
	codigo: INTEGER;
	descripcion: STRING[50];
	precio_unit: REAL;
	END;

	t_arch = FILE OF t_producto;

FUNCTION cargar_producto: t_producto;
VAR buffer: t_producto;

BEGIN
	WRITELN('DATOS DEL PRODUCTO');
	WRITE(' Cdigo: ');
	READLN(buffer.codigo);
	WRITE(' Descripcin: ');
	READLN(buffer.descripcion);
	WRITE(' Precio unitario: ');
	READLN(buffer.precio_unit);
	WRITELN;

	cargar_producto := buffer;
	END;

	PROCEDURE imprimir_producto(producto: t_producto);

BEGIN
	WRITELN('DATOS DEL PRODUCTO');
	WRITELN(' Cdigo: ', producto.codigo);
	WRITELN(' Descripcin: ', producto.descripcion);
	WRITELN(' Precio unitario: ', producto.precio_unit:6:2);
	WRITELN;
	END;

VAR 	stock: t_arch;
	buffer: t_producto;
	i: INTEGER;

{ Programa Principal }
BEGIN
	ASSIGN(stock,'stock.dat');
	{$I-}
	REWRITE(stock);
	{$I+}
	IF (IORESULT <> 0) THEN
		BEGIN
			WRITELN('No se puede abrir el archivo.');
			EXIT;
		END;

	{ Carga de datos en el archivo }
	FOR i:=1 TO N DO
	BEGIN
		buffer := cargar_producto();
		WRITE(stock, buffer);
	END;

	{ Lectura del ltimo registro (registro N-1) }
	SEEK(stock, FILESIZE(stock)-1);
	READ(stock, buffer);
	imprimir_producto(buffer);

	{ Posicionamiento sobre EOF (para agregar un registro al final) }
	SEEK(stock, FILESIZE(stock));
	buffer := cargar_producto();
	WRITE(stock, buffer);

	{ Listado secuencial del archivo }
	RESET(stock);
	WHILE (NOT EOF(stock)) DO
		BEGIN
			READ(stock, buffer);
			imprimir_producto(buffer);
		END;
	CLOSE(stock);
END.